//+------------------------------------------------------------------+
//|                                                   HelpCutter.mq4 |
//|                                                             myst |
//|                                        http://mystfd.seesaa.net/ |
//|                                                 mystfd@gmail.com |
//| 2009.09.29  v1.1 myst                                            |
//| 2009.09.29  v1.2 myst Time Modify                                |
//+------------------------------------------------------------------+
#property copyright "myst"
#property link      "http://mystfd.seesaa.net/"
#define  NL    "\n"

//---- input parameters
extern int   CloseYear     = 2009;    
extern int   CloseMonth    = 11;    
extern int   CloseDay      = 24;    
extern int   CloseHour     = 1;   
extern int   CloseMinute   = 34;      
extern int   CloseStopAfterHour  = 20;   
extern double CloseOverEquity = 900000;
extern int   RDBMagicNumber11 = 1; 
extern int   RDBMagicNumber12 = 2;  
extern int   RDBMagicNumber13 = 3; 
extern int   RDBMagicNumber14 = 4; 
extern int   RDBMagicNumber21 = 5; 
extern int   RDBMagicNumber22 = 6;  
extern int   RDBMagicNumber23 = 7;  
extern int   RDBMagicNumber24 = 8;  
extern int   OtherMagicNumber1 = 9; 
extern int   OtherMagicNumber2 = 10;  
extern int   OtherMagicNumber3 = 11;  
extern int   OtherMagicNumber4 = 12;  
extern int   OtherMagicNumber5 = 13;  
extern int   Slippage      = 300;    
extern bool  ComentEnable  = True;     
extern color clCloseBuy    = Blue;  
extern color clCloseSell   = Red;   
bool CompFlg = false;
datetime Timec;
datetime TimeBaff;
datetime StatTimec;
datetime EndTimec;
 
int init(){
   CompFlg = false;
}

void start() {
  double pBid, pAsk;
  int MN;
  Timec = TimeCurrent();
  TimeBaff = StrToTime("2009.11.24 01:10:00");
  StatTimec = StrToTime(CloseYear + "." + CloseMonth + "." + CloseDay  + " " + CloseHour + ":" + CloseMinute);
  EndTimec = StatTimec + CloseStopAfterHour*60*60;
  
  string Message;
  
   
   if(ComentEnable){
      Message = NL;
      Message = Message + "NowDay              = " + TimeToStr(Timec,TIME_DATE) + " " + TimeToStr(Timec,TIME_SECONDS ) + NL;      
      Message = Message + "CloseStart           = " + TimeToStr(StatTimec,TIME_DATE) + " " + TimeToStr(StatTimec,TIME_SECONDS )+ NL;
      Message = Message + "CloseEnd            = " + TimeToStr(EndTimec,TIME_DATE) + " " + TimeToStr(EndTimec,TIME_SECONDS )+ NL;
      Message = Message + "CloseOverEquity   = $" + CloseOverEquity + NL;
      Message = Message + "Equity                = $" + AccountEquity() + NL;
      // Message = Message + "TimeCurrent        =  " + Timec + NL;
      // Message = Message + "StatTimec           =  " + StatTimec + NL;
      //Message = Message + "EndTimec           =  " + EndTimec + NL;
      Message = Message + NL;
   }
  if (StatTimec < TimeCurrent() && EndTimec > TimeCurrent() ) {
      Message = Message + "+++ClosingTime+++" + NL;
      if (AccountEquity() >= CloseOverEquity){
         for (int i=OrdersTotal()-1; i>=0; i--) {
           if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
              MN = OrderMagicNumber( );
              if(MN != RDBMagicNumber11 && MN != RDBMagicNumber12 && MN != RDBMagicNumber13 && MN != RDBMagicNumber14 && MN != RDBMagicNumber21 && MN != RDBMagicNumber22 && MN != RDBMagicNumber23 && MN != RDBMagicNumber24 && MN != OtherMagicNumber1 && MN != OtherMagicNumber2 && MN != OtherMagicNumber3 && MN != OtherMagicNumber4 && MN != OtherMagicNumber5){
                if (OrderType()==OP_BUY) {
                  pBid=MarketInfo(OrderSymbol(), MODE_BID);
                  OrderClose(OrderTicket(), OrderLots(), pBid, Slippage, clCloseBuy);
                }
                if (OrderType()==OP_SELL) {
                  pAsk=MarketInfo(OrderSymbol(), MODE_ASK);
                  OrderClose(OrderTicket(), OrderLots(), pAsk, Slippage, clCloseSell);
                }
              }
           }
         }
         CompFlg = true;
       }
  }else{
      Message = Message + "---NotClosingTime---" + NL;
  }       
      if(ComentEnable){  
         
         if(CompFlg){
            Message = Message + NL;
            Message = Message + "AllCloseComplete" + NL;
         } 
         Message = Message + NL;
         Message = Message + " = Exclusion = " + NL;
         Message = Message + "RDBMagicNumber11 = " + RDBMagicNumber11 + NL;
         Message = Message + "RDBMagicNumber12 = " + RDBMagicNumber12 + NL;
         Message = Message + "RDBMagicNumber13 = " + RDBMagicNumber13 + NL;
         Message = Message + "RDBMagicNumber14 = " + RDBMagicNumber14 + NL;
         Message = Message + "RDBMagicNumber21 = " + RDBMagicNumber21 + NL;
         Message = Message + "RDBMagicNumber22 = " + RDBMagicNumber22 + NL;
         Message = Message + "RDBMagicNumber23 = " + RDBMagicNumber23 + NL;
         Message = Message + "RDBMagicNumber24 = " + RDBMagicNumber24 + NL;
         Message = Message + "OtherMagicNumber1 = " + OtherMagicNumber1 + NL;
         Message = Message + "OtherMagicNumber2 = " + OtherMagicNumber2 + NL;
         Message = Message + "OtherMagicNumber3 = " + OtherMagicNumber3 + NL;
         Message = Message + "OtherMagicNumber4 = " + OtherMagicNumber4 + NL;
         Message = Message + "OtherMagicNumber5 = " + OtherMagicNumber5 + NL;
         Message = Message + " ============= ";      
         Comment(Message);
      }
}

